package polyglot.ext.polyj.ast;

import polyglot.ast.*;
import polyglot.types.*;
import polyglot.visit.*;
import polyglot.util.*;

import polyglot.ext.jl.ast.*;

public class ExprParam_c extends Node_c implements ExprParam
{
    protected Expr expr;

    public ExprParam_c(Position pos, Expr expr) {
        super(pos);
        this.expr = expr;
    }

    public Expr expr() {
        return expr;
    }

    public ExprParam expr(Expr expr) {
        ExprParam_c n = (ExprParam_c) copy();
        n.expr = expr;
        return n;
    }

    public Object parameter() {
        return expr;
    }
    
    public String toString() {
        return expr.toString();
    }

    protected ExprParam_c reconstruct(Expr expr) {
        if (expr != this.expr) {
            ExprParam_c n = (ExprParam_c) copy();
            n.expr = expr;
            return n;
        }
        return this;
    }
    
    public Node visitChildren(NodeVisitor v) {
        Expr newExpr = (Expr) visitChild(expr, v);
        return reconstruct(newExpr);
    }
    
    public void prettyPrint(CodeWriter w, PrettyPrinter pp) {
        print(expr, w, pp);
    }

    public void translate(CodeWriter w, Translator tr) {
        // do nothing
    }
}
